码迷,mamicode.com
首页 > 其他好文 > 详细

Triangle

时间:2014-09-22 11:32:02      阅读:182      评论:0      收藏:0      [点我收藏+]

标签:triangle leetcode

Given a triangle, find the minimum path sum from top to bottom. Each step you may move to adjacent numbers on the row below.

For example, given the following triangle

[
     [2],
    [3,4],
   [6,5,7],
  [4,1,8,3]
]

The minimum path sum from top to bottom is 11 (i.e., 2 + 3 + 5 + 1 = 11).

Note:
Bonus point if you are able to do this using only O(n) extra space, where n is the total number of rows in the triangle.

首先上来就是DFS,代码如下(大的数据集无法AC,超时):

public class Solution {
    private int MinSum;
	private List<List<Integer>> triangle = new ArrayList<List<Integer>>();
	public int minimumTotal(List<List<Integer>> triangle) {
		if(triangle==null){
			return 0;
		}
		if(triangle.size()==1){
			return triangle.get(0).get(0);
		}
		this.MinSum = Integer.MAX_VALUE;
		this.triangle = triangle;
		search( 1, triangle.get(0).get(0), 0);
		return MinSum;
	}
	public void search(int step,int sum,int index){
		if(step==triangle.size()){
			if(sum<MinSum){
				MinSum = sum;
			}
		}else {
			for(int i=index;i<=index+1;i++){
				sum+=triangle.get(step).get(i);
				search(step+1, sum,i);
				sum-=triangle.get(step).get(i);
			}
		}	
	}
}

在discuss 看到一个非常好的动态规划思路:

This problem is quite well-formed in my opinion. The triangle has a tree-like structure, which would lead people to think about traversal algorithms such as DFS. However, if you look closely, you would notice that the adjacent nodes always share a ‘branch‘. In other word, there areoverlapping subproblems. Also, suppose x and y are ‘children‘ of k. Once minimum paths from x and y to the bottom are known, the minimum path starting from k can be decided in O(1), that is optimal substructure. Therefore, dynamic programming would be the best solution to this problem in terms of time complexity.

What I like about this problem even more is that the difference between ‘top-down‘ and ‘bottom-up‘ DP can be ‘literally‘ pictured in the input triangle. For ‘top-down‘ DP, starting from the node on the very top, we recursively find the minimum path sum of each node. When a path sum is calculated, we store it in an array (memoization); the next time we need to calculate the path sum of the same node, just retrieve it from the array. However, you will need a cache that is at least the same size as the input triangle itself to store the pathsum, which takes O(N^2) space. With some clever thinking, it might be possible to release some of the memory that will never be used after a particular point, but the order of the nodes being processed is not straightforwardly seen in a recursive solution, so deciding which part of the cache to discard can be a hard  job.

‘Bottom-up‘ DP, on the other hand, is very straightforward: we start from the nodes on the bottom row; the min pathsums for these nodes are the values of the nodes themselves. From there, the min pathsum at the ith node on the kth row would be the lesser of the pathsums of its two children plus the value of itself, i.e.:

minpath[k][i] = min( minpath[k+1][i], minpath[k+1][i+1]) + triangle[k][i];

 

 

Or even better, since the row minpath[k+1] would be useless after minpath[k] is computed, we can simply set minpath as a 1D array, and iteratively update itself:

For the kth level:
minpath[i] = min( minpath[i], minpath[i+1]) + triangle[k][i];

 

 

 

class Solution {
public:
   int minimumTotal(vector<vector<int> > &triangle) {
    int n = triangle.size();
    vector<int> minlen(triangle.back());
    for (int layer = n-2; layer >= 0; layer--) // For each layer
    {
        for (int i = 0; i <= layer; i++) // Check its every 'node'
        {
            // Find the lesser of its two children, and sum the current value in the triangle with it.
            minlen[i] = min(minlen[i], minlen[i+1]) + triangle[layer][i]; 
        }
    }
    return minlen[0];
}
};

Triangle

标签:triangle leetcode

原文地址:http://blog.csdn.net/huruzun/article/details/39472193

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!